Imports Telerik.WinControls.UI

Public Class Form1
    Inherits Form
    Private textBoxEditor As RadTextBoxElement

    Public Sub New()
        InitializeComponent()

        Me.RadListBox1.Virtualized = False
        Me.textBoxEditor = New RadTextBoxElement()
        Me.textBoxEditor.UseGenericBorderPaint = False
        Me.textBoxEditor.Padding = Padding.Empty
        AddHandler textBoxEditor.TextBoxItem.LostFocus, AddressOf TextBoxItem_LostFocus

        For Each item As RadListBoxItem In Me.RadListBox1.Items
            AddHandler item.DoubleClick, AddressOf item_DoubleClick
        Next item
    End Sub

    Private Sub item_DoubleClick(ByVal sender As Object, ByVal e As EventArgs)
        Dim listBoxItem As RadListBoxItem = TryCast(sender, RadListBoxItem)
        If Not listBoxItem Is Nothing Then
            Me.textBoxEditor.Text = listBoxItem.Text
            Me.textBoxEditor.TextBoxItem.AcceptsReturn = True
            AddHandler textBoxEditor.TextBoxItem.KeyDown, AddressOf TextBoxItem_KeyDown
            listBoxItem.Children.Add(textBoxEditor)
            Me.ActiveControl = Me.textBoxEditor.TextBoxItem.HostedControl
        End If
    End Sub

    Private Sub TextBoxItem_LostFocus(ByVal sender As Object, ByVal e As EventArgs)
        CloseTextBoxAndSave(True)
    End Sub

    Private Sub CloseTextBoxAndSave(ByVal saveChanges As Boolean)
        Dim listBoxItem As RadListBoxItem = CType(Me.RadListBox1.SelectedItem, RadListBoxItem)
        If listBoxItem.Children.Contains(Me.textBoxEditor) Then
            listBoxItem.Children.Remove(Me.textBoxEditor)
            If saveChanges Then
                listBoxItem.Text = Me.textBoxEditor.Text
            End If
        End If
    End Sub

    Private Sub TextBoxItem_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
        If e.KeyCode = Keys.Enter Then
            CloseTextBoxAndSave(True)
        ElseIf e.KeyCode = Keys.Escape Then
            CloseTextBoxAndSave(False)
        End If
    End Sub
End Class